<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceOrderItemData StructType
 * @subpackage Structs
 */
class ServiceOrderItemData extends AbstractStructBase
{
    /**
     * The orderItemType
     * @var int
     */
    public $orderItemType;
    /**
     * The installmentChargeWithVAT
     * @var float
     */
    public $installmentChargeWithVAT;
    /**
     * The price
     * @var float
     */
    public $price;
    /**
     * The totalDiscountPrice
     * @var float
     */
    public $totalDiscountPrice;
    /**
     * The quantity
     * @var int
     */
    public $quantity;
    /**
     * The sellerInvoiceAmount
     * @var float
     */
    public $sellerInvoiceAmount;
    /**
     * The orderItemList
     * @var \StructType\ProductOrderItemList
     */
    public $orderItemList;
    /**
     * Constructor method for ServiceOrderItemData
     * @uses ServiceOrderItemData::setOrderItemType()
     * @uses ServiceOrderItemData::setInstallmentChargeWithVAT()
     * @uses ServiceOrderItemData::setPrice()
     * @uses ServiceOrderItemData::setTotalDiscountPrice()
     * @uses ServiceOrderItemData::setQuantity()
     * @uses ServiceOrderItemData::setSellerInvoiceAmount()
     * @uses ServiceOrderItemData::setOrderItemList()
     * @param int $orderItemType
     * @param float $installmentChargeWithVAT
     * @param float $price
     * @param float $totalDiscountPrice
     * @param int $quantity
     * @param float $sellerInvoiceAmount
     * @param \StructType\ProductOrderItemList $orderItemList
     */
    public function __construct($orderItemType = null, $installmentChargeWithVAT = null, $price = null, $totalDiscountPrice = null, $quantity = null, $sellerInvoiceAmount = null, \StructType\ProductOrderItemList $orderItemList = null)
    {
        $this
            ->setOrderItemType($orderItemType)
            ->setInstallmentChargeWithVAT($installmentChargeWithVAT)
            ->setPrice($price)
            ->setTotalDiscountPrice($totalDiscountPrice)
            ->setQuantity($quantity)
            ->setSellerInvoiceAmount($sellerInvoiceAmount)
            ->setOrderItemList($orderItemList);
    }
    /**
     * Get orderItemType value
     * @return int|null
     */
    public function getOrderItemType()
    {
        return $this->orderItemType;
    }
    /**
     * Set orderItemType value
     * @param int $orderItemType
     * @return \StructType\ServiceOrderItemData
     */
    public function setOrderItemType($orderItemType = null)
    {
        // validation for constraint: int
        if (!is_null($orderItemType) && !(is_int($orderItemType) || ctype_digit($orderItemType))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($orderItemType, true), gettype($orderItemType)), __LINE__);
        }
        $this->orderItemType = $orderItemType;
        return $this;
    }
    /**
     * Get installmentChargeWithVAT value
     * @return float|null
     */
    public function getInstallmentChargeWithVAT()
    {
        return $this->installmentChargeWithVAT;
    }
    /**
     * Set installmentChargeWithVAT value
     * @param float $installmentChargeWithVAT
     * @return \StructType\ServiceOrderItemData
     */
    public function setInstallmentChargeWithVAT($installmentChargeWithVAT = null)
    {
        // validation for constraint: float
        if (!is_null($installmentChargeWithVAT) && !(is_float($installmentChargeWithVAT) || is_numeric($installmentChargeWithVAT))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($installmentChargeWithVAT, true), gettype($installmentChargeWithVAT)), __LINE__);
        }
        $this->installmentChargeWithVAT = $installmentChargeWithVAT;
        return $this;
    }
    /**
     * Get price value
     * @return float|null
     */
    public function getPrice()
    {
        return $this->price;
    }
    /**
     * Set price value
     * @param float $price
     * @return \StructType\ServiceOrderItemData
     */
    public function setPrice($price = null)
    {
        // validation for constraint: float
        if (!is_null($price) && !(is_float($price) || is_numeric($price))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($price, true), gettype($price)), __LINE__);
        }
        $this->price = $price;
        return $this;
    }
    /**
     * Get totalDiscountPrice value
     * @return float|null
     */
    public function getTotalDiscountPrice()
    {
        return $this->totalDiscountPrice;
    }
    /**
     * Set totalDiscountPrice value
     * @param float $totalDiscountPrice
     * @return \StructType\ServiceOrderItemData
     */
    public function setTotalDiscountPrice($totalDiscountPrice = null)
    {
        // validation for constraint: float
        if (!is_null($totalDiscountPrice) && !(is_float($totalDiscountPrice) || is_numeric($totalDiscountPrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($totalDiscountPrice, true), gettype($totalDiscountPrice)), __LINE__);
        }
        $this->totalDiscountPrice = $totalDiscountPrice;
        return $this;
    }
    /**
     * Get quantity value
     * @return int|null
     */
    public function getQuantity()
    {
        return $this->quantity;
    }
    /**
     * Set quantity value
     * @param int $quantity
     * @return \StructType\ServiceOrderItemData
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: int
        if (!is_null($quantity) && !(is_int($quantity) || ctype_digit($quantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->quantity = $quantity;
        return $this;
    }
    /**
     * Get sellerInvoiceAmount value
     * @return float|null
     */
    public function getSellerInvoiceAmount()
    {
        return $this->sellerInvoiceAmount;
    }
    /**
     * Set sellerInvoiceAmount value
     * @param float $sellerInvoiceAmount
     * @return \StructType\ServiceOrderItemData
     */
    public function setSellerInvoiceAmount($sellerInvoiceAmount = null)
    {
        // validation for constraint: float
        if (!is_null($sellerInvoiceAmount) && !(is_float($sellerInvoiceAmount) || is_numeric($sellerInvoiceAmount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($sellerInvoiceAmount, true), gettype($sellerInvoiceAmount)), __LINE__);
        }
        $this->sellerInvoiceAmount = $sellerInvoiceAmount;
        return $this;
    }
    /**
     * Get orderItemList value
     * @return \StructType\ProductOrderItemList|null
     */
    public function getOrderItemList()
    {
        return $this->orderItemList;
    }
    /**
     * Set orderItemList value
     * @param \StructType\ProductOrderItemList $orderItemList
     * @return \StructType\ServiceOrderItemData
     */
    public function setOrderItemList(\StructType\ProductOrderItemList $orderItemList = null)
    {
        $this->orderItemList = $orderItemList;
        return $this;
    }
}
